unit IndicatorUnit;
(*

This component was programmed by {MSX}
3 october 2001
in Venice (Italy)

Use This freely. If you like it, please tell me at

msx_80@hotmail.com

http://msx.rules.it


}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TIndicator = class(TGraphicControl)
  private
   fPos:integer;
   fmin,fmax:integer;
   fcolor:TColor;
   FOnChange:TNotifyEvent;
   procedure SetFpos(value:integer);
   procedure SetFmax(value:integer);
   procedure SetFColor(value:Tcolor);
   procedure SetFmin(value:integer);
    { Private declarations }
  protected
    { Protected declarations }
  public
   procedure Paint; override;
   constructor Create(AOwner: TComponent); override;
    { Public declarations }
  published
   property Position:integer read Fpos write SetFpos;
   property Max:integer read fMax write SetFmax;
   property Min:integer read fmin write SetFmin;
   property Color:TColor read fcolor write SetFColor;
   property OnChange: TNotifyEvent read FOnChange write FOnChange;
    { Published declarations }
  end;

procedure Register;

implementation
procedure TIndicator.SetFColor(value:Tcolor);
begin
fcolor:=value;
repaint;
end;
procedure TIndicator.SetFpos(value:integer);
begin
if fpos<>value then
 begin
  fpos:=value;
  if Assigned(FOnChange) then FOnChange(Self);
  repaint;
 end;
end;
procedure TIndicator.SetFmax(value:integer);
begin
fmax:=value;
repaint;
end;
procedure TIndicator.SetFmin(value:integer);
begin
fmin:=value;
repaint;
end;

constructor TIndicator.Create(AOwner: TComponent);
begin
inherited create(aowner);
width:=120;
height:=90;
max:=100;
min:=0;
fcolor:=clred;
end;
procedure TIndicator.Paint;
var x:integeR;
    a:real;
    p1,p2,p3:TPoint;
begin
a:=(fpos-min)*pi/(max-min);
if a>pi then a:=pi;
if a<0 then a:=0;
p1.x:=(Width div 2)+trunc(10*cos(a+pi*5/4));
p1.y:=(Height-25)-trunc(10*sin(a+pi*5/4));
p2.x:=(Width div 2)+trunc(50*cos(a));
p2.y:=(Height-25)-trunc(50*sin(a));
p3.x:=(Width div 2)+trunc(10*cos(a+pi*3/4));
p3.y:=(Height-25)-trunc(10*sin(a+pi*3/4));

with Canvas do
 begin
  arc(Width div 2 + 45, Height-25 +45,Width div 2 - 44, Height-25 -45,width,height -25,0,height -24);
  moveto(Width div 2 + 45, Height-25);
  lineto(Width div 2 - 45, Height-25);
  brush.Style:=bsClear;
  textout(Width div 2 + 45 ,Height-24,inttostr(min));
  textout(Width div 2 - 55 ,Height-24,inttostr(max));
  brush.Color:=fcolor;
  Polygon([p1,p2,p3]);
  
{  moveto(150+p1.x,180-p1.y);
  LineTo(150+p2.x,180-p2.y);
  LineTo(150+p3.x,180-p3.y);
  LineTo(150+p1.x,180-p1.y);}
 end;
end;

procedure Register;
begin
  RegisterComponents('MSX', [TIndicator]);
end;

end.
 