program TestRBTree;

uses
  SysUtils,
  ExtSys,
  RBTree;

{$APPTYPE CONSOLE}

type
  TIntegerRBTree = class(TRBTree)
  protected
    procedure WriteItem(const Item: Pointer);
  public
    procedure DebugWrite;
  end;

procedure TIntegerRBTree.WriteItem(const Item: Pointer);
begin
  write(Integer(Item), ' ');
end;

procedure TIntegerRBTree.DebugWrite;
begin
  UpwardTraversal(WriteItem);
  writeln;
end;

procedure Test1;
var
  a, maxnum, ct, amin, amax: Integer;
  RBTree: TRBTree;
begin
  RBTree:=TIntegerRBTree.Create;
  try
    if ParamCount > 0 then maxnum:=StrToInt(ParamStr(1)) else maxnum:=1000;
    for ct:=maxnum - 1 downto 0 do begin
      a:=random(maxnum);
      if RBTree.Find(Pointer(a)) then
        RBTree.Delete(Pointer(a))
      else
        RBTree.Add(Pointer(a));
    end;
    amin:=MaxInt;
    amax:=0;
    RBTree.Clear;
    for ct:=maxnum - 1 downto 0 do begin
      a:=random(maxnum);
      if a < amin then amin:=a;
      if a > amax then amax:=a;
      RBTree.Add(Pointer(a));
    end;
    if MaxNum > 0 then
      if (amin <> Integer(RBTree.Min)) or (amax <> Integer(RBTree.Max)) then begin
        write('Error! amin=', amin, ' RBTree.Min=', Integer(RBTree.Min),
          ' amax=', amax, ' RBTree.Max=', Integer(RBTree.Max));
        readln;
      end;
  finally
    RBTree.Free;
  end;
end;

procedure Test2;
var
  RBTree: TIntegerRBTree;
  I: Integer;
begin
  RBTree:=TIntegerRBTree.Create;
  try
    for I:=0 to 10 do
      RBTree.Add(Pointer(I));
    RBTree.DebugWrite;
  finally
    RBTree.Free;
  end;
end;

begin
  Test1;
  writeln('Test1 Ok');
  Test2;
  writeln('Test2 Ok');
  write('Press Return to continue...');
  readln;
end.