{ Version 010116 Copyright  Alexey A.Chernobaev, 1996-2001 }

unit Boolm;
{
   .

  Boolean matrixes.
}

interface

{$I VCheck.inc}

uses
  SysUtils, ExtType, ExtSys, Vectors, Boolv, Pointerv, Int16g, Aliasv, VStream,
  VFormat, VTxtStrm, VectErr;

{$DEFINE BOOL}

type
  BaseType = Bool;
  TGenericBaseVector = TBoolVector;
  TBaseVector = TBoolVector;
  TSparseVector = TPackedBoolVector;

  {$I NumMatr.def}

  TBoolMatrix = TNumberMatrix;
  TSquareBoolMatrix = TSquareMatrix;
  TSparseBoolMatrix = TSparseMatrix;
  TPackedBoolMatrix = TSparseMatrix;
  TSimBoolMatrix = TSimMatrix;
  TSparseSimBoolMatrix = TSparseSimMatrix;
  TPackedSimBoolMatrix = TSparseSimMatrix;

  TBooleanMatrix = TBoolMatrix;
  TSparseBooleanMatrix = TSparseBoolMatrix;
  TPackedBooleanMatrix = TPackedBoolMatrix;
  TSparseSimBooleanMatrix = TSparseSimBoolMatrix;
  TPackedSimBooleanMatrix = TPackedSimBoolMatrix;

function CreateBoolMatrix(ARowCount, AColCount: Integer; ADefaultValue: Bool): TBoolMatrix;
{          
  TBoolMatrix  ,     TBoolMatrix, 
     TPackedBoolMatrix }
{ if amount of free physical memory is large enough to store matrix of class
  TBoolMatrix with dimensionality ARowCount * AColCount then creates such matrix
  else creates matrix of class TPackedBoolMatrix }

function CreateSimBoolMatrix(ASize: Integer; ADefaultValue: Bool): TBoolMatrix;
{  CreateBoolMatrix    (  
  TSimBoolMatrix  TPackedSimBoolMatrix) }
{ analog of CreateBoolMatrix for symmetric matrixes (creates matrix of classes
  either TSimBoolMatrix or TPackedSimBoolMatrix) }

implementation

{$I NumMatr.imp}

{$UNDEF BOOL}

function CreateBoolMatrix(ARowCount, AColCount: Integer; ADefaultValue: Bool): TBoolMatrix;
begin
  if PhysicalMemoryFree > UInt32(ARowCount * AColCount) then
    Result:=TBoolMatrix.Create(ARowCount, AColCount, ADefaultValue)
  else
    Result:=TPackedBoolMatrix.Create(ARowCount, AColCount, ADefaultValue);
end;

function CreateSimBoolMatrix(ASize: Integer; ADefaultValue: Bool): TBoolMatrix;
begin
  if PhysicalMemoryFree > UInt32(ASize div 2 * ASize) then
    Result:=TSimBoolMatrix.Create(ASize, ADefaultValue)
  else
    Result:=TPackedSimBoolMatrix.Create(ASize, ADefaultValue);
end;

end.
