{ Version 990825. Copyright  Alexey A.Chernobaev, 1996-1999 }

unit ChckFree;
{
       ,  ,
         .
}

interface

uses
  SysUtils, Classes, Forms, Controls, WinTypes, WinProcs, LogFile;

procedure RegisterObjectCreate(AnObject: TObject);
procedure RegisterObjectFree(AnObject: TObject);

implementation

const
  LogFileName = 'free_err.log';
  MaxLogSize = 32768;

  CreatedObjects: TList = nil;

procedure RegisterObjectCreate(AnObject: TObject);
begin
  if CreatedObjects <> nil then CreatedObjects.Add(AnObject);
end;

procedure RegisterObjectFree(AnObject: TObject);
var
  I: Integer;
begin
  if CreatedObjects <> nil then begin
    I:=CreatedObjects.IndexOf(AnObject);
    if I >= 0 then CreatedObjects.Delete(I);
  end;
end;

procedure CheckAllFree;
var
  I: Integer;
  FileName: String;
begin
  if CreatedObjects.Count > 0 then begin
    FileName:=ExtractFilePath(Application.ExeName) + LogFileName;
    if Application.MessageBox(
      {$IFDEF WIN32}
      PChar(Format('CheckFree has found some objects were not freed.'#13 +
        'Add report to log file ''%s''?', [FileName])),
      {$ELSE}
      'CheckFree has found some objects were not freed.'#13 +
        'Add report to log file ''' + LogFileName + '''?',
      {$ENDIF}
      'Warning',
      MB_YESNO) = IDYES then
    begin
      WriteStringToLog(FileName, ['*** CheckFree ***'], MaxLogSize, True);
      for I:=0 to CreatedObjects.Count - 1 do
        WriteStringToLog(FileName, [TObject(CreatedObjects[I]).ClassName],
          MaxLogSize, False);
      WriteStringToLog(FileName, ['*** end ***'], MaxLogSize, False);
    end;
  end;
end;

procedure NewExitProc; far;
begin
  CheckAllFree;
  CreatedObjects.Free;
  CreatedObjects:=nil;
end;

initialization
  CreatedObjects:=TList.Create;
  AddExitProc(NewExitProc);
end.
