{ Version 000613. Copyright  Alexey A.Chernobaev, 1996-2000 }

unit Int16v;

interface

{$I VCheck.inc}

uses
  ExtType, ExtSys, Vectors, Base16v, Int16g, VectErr;

type
  TNumberVector = class(TGenericNumberVector)
  {$I VFast.def}
    procedure Sort; override; { use radix sort if the vector is small enough }
    procedure SortDesc; override;
  end;

  TInt16Vector = TNumberVector;
  TSmallIntVector = TInt16Vector;

implementation

uses VectProc;

const
  AddVectCode = AddInt16;
  SubVectCode = SubInt16;
  AddScalarCode = AddScalarInt16;
  SubScalarCode = SubScalarInt16;
  MulScalarCode = MulScalarInt16;
  DivScalarCode = DivScalarInt16;
  SumVectCode = SumInt16;

{$DEFINE SPECIAL_MUL}
{$I VFast.imp}
{$UNDEF SPECIAL_MUL}

procedure TNumberVector.MulScalar(T: NumberType);
begin
  VectProcs[MulInt16](FItems^, T, FCount);
end;

function TNumberVector.DotProduct(V: TGenericNumberVector): Int32;
begin
  {$IFDEF CHECK_VECTORS}
  if Count <> V.Count then Error(SWrongVectorSize, [V.Count]);
  {$ENDIF}
  if ClassType = V.ClassType then
    Result:=VectFuncsInt32[DotProductInt16](FItems^, TNumberVector(V).FItems^, Count)
  else
    Result:=inherited DotProduct(V);
end;

{$I Sort16s.inc}
{$DEFINE V_SORT_DESC}
{$I Sort16s.inc}
{$UNDEF V_SORT_DESC}

end.

