{ Version 000713. Copyright  Alexey A.Chernobaev, 1996-2000 }

unit VCLCmpt;
{
  Vectors library and VCL compatibility unit.
}

interface

uses
  VStream, Classes, StrLst;

procedure CopyToMemoryStream(Source: TVMemStream; Destin: TMemoryStream);
{ TVMemStream -> TMemoryStream }

procedure CopyToVMemStream(Source: TMemoryStream; Destin: TVMemStream);
{ TMemoryStream -> TVMemStream }

procedure CopyToStrings(Source: TStrLst; Destin: TStrings);
{ TStrLst -> TStrings }

procedure CopyToStrLst(Source: TStrings; Destin: TStrLst);
{ TStrings -> TStrLst }

implementation

procedure CopyToMemoryStream(Source: TVMemStream; Destin: TMemoryStream);
begin
  Destin.SetSize(Source.Size);
  if Source.Size > 0 then Move(Source.Memory^, Destin.Memory^, Source.Size);
end;

procedure CopyToVMemStream(Source: TMemoryStream; Destin: TVMemStream);
begin
  Destin.Size:=Source.Size;
  if Source.Size > 0 then Move(Source.Memory^, Destin.Memory^, Source.Size);
end;

procedure CopyToStrings(Source: TStrLst; Destin: TStrings);
var
  I: Integer;
begin
  Destin.Clear;
  for I:=0 to Source.Count - 1 do Destin.Add(Source[I]);
end;

procedure CopyToStrLst(Source: TStrings; Destin: TStrLst);
var
  I: Integer;
begin
  Destin.Count:=Source.Count;
  for I:=0 to Source.Count - 1 do Destin[I]:=Source[I];
end;

end.
