{ Version 001119. Copyright  Alexey A.Chernobaev, 1996-2000 }

unit VFStream;

interface

{$I VCheck.inc}

uses
  {$IFDEF WIN32}Windows,{$ENDIF} SysUtils, ExtType, VStream, Crc32, VectErr;

type
  ILong = Int32;

  TVBaseStream = TVStream;

{$I VFStrm.def}

  TVFileStream32 = TVFileStream;
  TVCRCFileStream32 = TVCRCFileStream;
  TVBufFileStream32 = TVBufFileStream;

implementation

{$I VFStrm.imp}

constructor TVFileStream.Create(const AFileName: String; Mode: Word);
begin
  {$IFDEF CHECK_OBJECTS_FREE}
  RegisterObjectCreate(Self);
  {$ENDIF}
  inherited Create;
  FFileName:=AFileName;
  FFileMode:=Mode;
  OpenHandle(Mode);
  FSize:=-1;
  {$IFDEF WIN32}
  GetSize;
  {$ENDIF}
end;

function TVFileStream.GetSize: Int32;
{$IFDEF WIN32}
var
  Err: Int32;
{$ENDIF}
begin
  if FSize < 0 then begin
    if FHandle = BadHandle then ReopenHandle;
    {$IFDEF WIN32}
    FSize:=GetFileSize(FHandle, @Err);
    if (Err <> 0) or (FSize < 0) then Error(SFileTooLong);
    {$ELSE}
    FSize:=FileSeek(FHandle, 0, 2);
    if (FSize < 0) or (FileSeek(FHandle, FPosition, 0) < 0) then Error(SGetSizeError);
    {$ENDIF}
  end;
  Result:=FSize;
end;

end.
