{ Version 000623. Copyright  Alexey A.Chernobaev, 1996-2000 }

unit VFstTmr;

interface

{$I VCheck.inc}

uses
  ExtType, {$IFDEF WIN32}Windows{$ELSE}WinTypes, WinProcs{$ENDIF};

type
  TVFastTimer = class
  private
    HighResolutionHardware, Started: Bool;
    {$IFDEF WIN32}
    Freq, StartTime, StopTime: TLargeInteger;
    {$ENDIF}
    StartTick, StopTick: Int32;
  public
    {$IFDEF WIN32}
    constructor Create;
    {$ENDIF}
    procedure Start;
    {   }
    procedure Stop;
    {   }
    function UsedTime: Float;
    {     Start,      
      ( / );    ,   
       Stop,      
       Start  Stop;     ,   0 }
    procedure Report;
    {  UsedTime  stdout }
    { reports UsedTime to the stdout }
  end;

implementation

{$IFDEF WIN32}
constructor TVFastTimer.Create;
begin
  inherited Create;
  HighResolutionHardware:=QueryPerformanceFrequency(Freq);
end;
{$ENDIF}

procedure TVFastTimer.Start;
begin
  {$IFDEF WIN32}
  if HighResolutionHardware then
    QueryPerformanceCounter(StartTime)
  else
  {$ENDIF}
    StartTick:=GetTickCount;
  Started:=True;
end;

procedure TVFastTimer.Stop;
begin
  {$IFDEF WIN32}
  if HighResolutionHardware then
    QueryPerformanceCounter(StopTime)
  else
  {$ENDIF}
    StopTick:=GetTickCount;
  Started:=False;
end;

{$IFDEF NOWARN}{$WARNINGS OFF}{$ENDIF}
function TVFastTimer.UsedTime: Float;
var
{$IFDEF WIN32}
  T1: TLargeInteger;
{$ENDIF}
  T2: Int32;
begin
  if Started then
    {$IFDEF WIN32}
    if HighResolutionHardware then
      QueryPerformanceCounter(T1)
    else
    {$ENDIF}
      T2:=GetTickCount
  else
    {$IFDEF WIN32}
    if HighResolutionHardware then
      T1:=StopTime
    else
    {$ENDIF}
      T2:=StopTick;
  {$IFDEF WIN32}
  if HighResolutionHardware then
    {$IFDEF V_D4}
    Result:=Abs(T1 - StartTime) / Freq
    {$ELSE}
    {$IFDEF V_FREEPASCAL}
    Result:=Abs(Int64(T1) - Int64(StartTime)) / Int64(Freq)
    {$ELSE}
    Result:=Abs(T1.QuadPart - StartTime.QuadPart) / Freq.QuadPart
    {$ENDIF}
    {$ENDIF}
  else
  {$ENDIF}
    Result:=Abs(T2 - StartTick) / 1000;
end;
{$IFDEF NOWARN}{$WARNINGS ON}{$ENDIF}

procedure TVFastTimer.Report;
begin
  writeln(UsedTime :0:2, ' sec');
end;

end.
